/*
** Copyright (C) 1993-2013 Mark B. Hanson (mbh@panix.com)
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// @(#)$Id: global.h 1344 2013-04-05 21:18:39Z mark $

#ifndef	XSC_GLOBAL_H
#define	XSC_GLOBAL_H

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif	// HAVE_CONFIG_H

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>

/* gross, but this seems to work the best for now */
#include <stdio.h>
#include <cstdio>

#include <stddef.h>
#include <cstddef>

#include <cstdlib>
#include <stdlib.h>

#include <math.h>
#include <cmath>

#include <limits.h>
#include <climits>

#ifdef	DEBUG
#undef	NDEBUG
#include <assert.h>
#include <cassert>
#endif	// DEBUG


#ifndef	NULL
#define	NULL	0
#endif	/* NULL */

struct coords {
    float x;
    float y;
};

enum key_state {
    KEY_UP,
    KEY_DOWN
};


inline int
within(const float a, const float b, const float c)
{
    return (a >= (b - c) && a <= (b + c));
} // ::within


inline int
sign(const float a)
{
    return (a > 0.0) ? +1 : -1;
} // ::sign


inline float
max(const float a, const float b)
{
    return (a > b) ? a : b;
} // ::max


inline float
min(const float a, const float b)
{
    return (a < b) ? a : b;
} // ::min


inline float
sq(const float x)
{
    return x * x;
} // ::sq

#endif	// XSC_GLOBAL_H
